#include <string.h>
#include <stdio.h>
#include <windows.h>
#include "service.h"

PROCESS_INFORMATION server;

void ServiceStop() {
    TerminateProcess(server.hProcess, 0);
}

void ServiceStart(DWORD dwArgc, LPSTR *lpszArgv ) {
    char buf[MAX_PATH], cwd[MAX_PATH], *p;
    DWORD sz, type;
    HKEY jdk;
    BOOL ret;
    STARTUPINFO startupInfo = {
      sizeof(STARTUPINFO),
      NULL,
      NULL, 
      NULL, 
      0, 
      0, 
      0, 
      0, 
      0, 
      0, 
      0,
      0, 
      0, 
      0, 
      NULL, 
      NULL, 
      NULL, 
      NULL
    };

    // report the status to the service control manager.
    if (!ReportStatusToSCMgr(
        (DWORD)SERVICE_RUNNING, // service state
        NO_ERROR,              // exit code
        (DWORD)0))                 // wait hint
        return;

    strcpy(buf, "");
    RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\JavaSoft\\Java Development Kit\\1.1", 0, KEY_QUERY_VALUE, &jdk);
    sz = MAX_PATH;
    RegQueryValueEx(jdk, "JavaHome", 0, &type, buf, &sz);

    if (!strcmp("", buf))
      return;

    GetModuleFileName(NULL, cwd, MAX_PATH);
    p = cwd + strlen(cwd);

    while (*p != '\\') --p;
    *p = '\0';

    sprintf(buf, "%s\\bin\\javaw.exe", buf);
    ret = CreateProcess(
      buf,
      // Qui la riga di comando per l'interprete Java.
      " it.unipi.di.vserver.ServerManager none none CompassProtocol",
      NULL,
      NULL,
      TRUE,
      NORMAL_PRIORITY_CLASS,
      NULL,
      cwd,
      (LPSTARTUPINFO) &startupInfo,
      (LPPROCESS_INFORMATION) &server
    );

    WaitForSingleObject(server.hProcess, INFINITE);
}

/* Nothing to do */
void ServiceRemove() {
}

/* Nothing to do */
void ServiceInstall() {
}

